/**
 * Modern Albufeira Prolog Interpreter
 *
 * Warranty & Liability
 * To the extent permitted by applicable law and unless explicitly
 * otherwise agreed upon, XLOG Technologies AG makes no warranties
 * regarding the provided information. XLOG Technologies AG assumes
 * no liability that any problems might be solved with the information
 * provided by XLOG Technologies AG.
 *
 * Rights & License
 * All industrial property rights regarding the information - copyright
 * and patent rights in particular - are the sole property of XLOG
 * Technologies AG. If the company was not the originator of some
 * excerpts, XLOG Technologies AG has at least obtained the right to
 * reproduce, change and translate the information.
 *
 * Reproduction is restricted to the whole unaltered document. Reproduction
 * of the information is only allowed for non-commercial uses. Selling,
 * giving away or letting of the execution of the library is prohibited.
 * The library can be distributed as part of your applications and libraries
 * for execution provided this comment remains unchanged.
 *
 * Restrictions
 * Only to be distributed with programs that add significant and primary
 * functionality to the library. Not to be distributed with additional
 * software intended to replace any components of the library.
 *
 * Trademarks
 * Jekejeke is a registered trademark of XLOG Technologies AG.
 */

import {exec_build, exec_unify, add, check_nonvar, Compound,
    copy_term, fs, html_send, make_error, Sink, make_check,
    stream_flush, put_atom, stream_close, fiddle_out
} from "../../nova/core.mjs";
import {
    xml_escape
} from "./auxlib.mjs";

/*****************************************************************/
/* Sink API                                                      */
/*****************************************************************/

/**
 * ir_is_sink(O):
 * The predicate succeeds if O is a sink.
 */
function test_ir_is_sink(args) {
    let obj = exec_build(args[0]);
    return (obj instanceof Sink);
}

/*****************************************************************/
/* DOM Machine                                                   */
/*****************************************************************/

/**
 * ir_is_element(O):
 * The predicate succeeds if O is a DOM element.
 */
function test_ir_is_element(args) {
    let obj = exec_build(args[0]);
    if (fs !== undefined) {
        return false;
    } else {
        return (obj instanceof Element);
    }
}

/*****************************************************************/
/* Markup Streams                                                */
/*****************************************************************/

/**
 * dom_output_new(S, W):
 * The predicate succeeds in W with a new markup writer to the stream S.
 */
function test_dom_output_new(args) {
    let obj = exec_build(args[0]);
    let dst;
    if (obj instanceof Sink) {
        dst = new Sink();
        dst.data = obj;
        dst.send = xml_send;
        dst.notify = stream_flush;
        dst.release = stream_close;
        dst.buf = null;
    } else {
        check_element(obj);
        let dom = new Sink();
        dom.data = obj;
        dom.send = fiddle_out;

        dst = new Sink();
        dst.data = dom;
        dst.send = html_send;
        dst.notify = stream_flush;
        dst.release = stream_close;
        dst.buf = null;
    }
    return exec_unify(args[1], dst);
}

export function check_element(beta) {
    if (!(beta instanceof Element)) {
        check_nonvar(beta);
        beta = copy_term(beta);
        throw make_error(new Compound("type_error", ["element", beta]));
    }
}

function xml_send(data, buf) {
    let text = xml_escape(buf);
    put_atom(data, text);
    return data;
}

/*********************************************************************/
/* Dom Lib Init                                                      */
/*********************************************************************/

export function main() {
    add("ir_is_sink", 1, make_check(test_ir_is_sink));
    add("ir_is_element", 1, make_check(test_ir_is_element));
    add("dom_output_new", 2, make_check(test_dom_output_new));
}